package gssim.gssimstudio.flex.app.editor;

import java.io.*;
import java.util.*;

import org.vinetoolkit.ResourceManager;
import org.vinetoolkit.ServiceContext;
import org.vinetoolkit.Session;

import org.vinetoolkit.web.spi.annotation.BlazeDsDestination;
import org.vinetoolkit.web.spi.annotation.BlazeDsMethod;
import org.vinetoolkit.web.flex.blazeds.shared.utils.VineFlexUtilClass;
import org.vinetoolkit.web.portlet.spi.annotation.PortletDisplayName;
import org.vinetoolkit.role.VineRoleManager;
import org.vinetoolkit.spi.util.ServiceLog;

import org.vinetoolkit.grms3client.GRMS3ClientModule;
import org.vinetoolkit.grms3client.GRMS3ClientResource;
import org.vinetoolkit.grms3client.GRMS3Job;
import org.vinetoolkit.grms3client.GRMS3Resource;
import org.vinetoolkit.grms3client.GRMS3ReturnType;
import org.vinetoolkit.grms3client.GRMS3Task;
import org.vinetoolkit.grms3client.web.app.GRMS3JobImpl;
import org.vinetoolkit.grms3client.web.app.GRMS3ResourceImpl;
//import org.vinetoolkit.grms3client.web.app.GRMS3Status;

import flex.messaging.FlexContext;
import org.vinetoolkit.web.spi.annotation.BlazeDsDestination;
import org.vinetoolkit.web.spi.annotation.BlazeDsMethod;
import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.disk.DiskFileItem;
import org.vinetoolkit.io.*;
import org.vinetoolkit.io.sets.FileLocationSet;
import org.vinetoolkit.ServiceContext;
import org.vinetoolkit.Location;
import org.vinetoolkit.task.TaskMonitor;
import org.vinetoolkit.task.TaskOptions;
import org.vinetoolkit.task.TaskException;
import org.vinetoolkit.localhost.io.FileSystemResource;
import org.vinetoolkit.localhost.io.FileSystemManager;
import org.vinetoolkit.spi.util.ServiceLog;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Timestamp;

import org.vinetoolkit.web.flex.blazeds.shared.uibackend.ModelInitialization;
import org.vinetoolkit.web.flex.blazeds.shared.uibackend.FileUploadAccepter;
import java.security.Principal;

import gssim.db.dao.data.Allocation;
import gssim.db.dao.data.AllocationDetails;
import gssim.db.dao.data.BlobProperty;
import gssim.db.dao.data.Configuration;
import gssim.db.dao.data.Metaexperiment;
import gssim.db.dao.data.Experiment;
import gssim.db.dao.data.ExperimentStats;
import gssim.db.dao.data.Queues;
import gssim.db.dao.data.Plugin;
import gssim.db.dao.data.PluginCompatibility;
import gssim.db.dao.data.Reservation;
import gssim.db.dao.data.ReservationDetails;
import gssim.db.dao.data.Resource;
import gssim.db.dao.data.ResourceAllTimeline;
import gssim.db.dao.data.ResourceEnTimeline;
import gssim.db.dao.data.Task;
import gssim.db.dao.data.TextProperty;
import gssim.db.dao.data.ApplicationProperty;
import gssim.db.dao.data.Unit;
import gssim.db.dao.data.UnitAllTimeline;
import gssim.db.dao.data.UnitDetails;
import gssim.db.dao.data.UnitEnTimeline;
import gssim.db.dao.data.User;
import gssim.db.find.Finder;
import gssim.db.mysql.AllocationDAO;
import gssim.db.mysql.AllocationDetailsDAO;
import gssim.db.mysql.BlobPropertyDAO;
import gssim.db.mysql.ConfigurationDAO;
import gssim.db.mysql.ExperimentDAO;
import gssim.db.mysql.MetaexperimentDAO;
import gssim.db.mysql.ExperimentStatsDAO;
import gssim.db.mysql.MySQLDAOFactory;
import gssim.db.mysql.QueuesDAO;
import gssim.db.mysql.PluginDAO;
import gssim.db.mysql.PluginCompatibilityDAO;
import gssim.db.mysql.ReservationDAO;
import gssim.db.mysql.ReservationDetailsDAO;
import gssim.db.mysql.ResourceAllTimelineDAO;
import gssim.db.mysql.ResourceDAO;
import gssim.db.mysql.ResourceEnTimelineDAO;
import gssim.db.mysql.TaskDAO;
import gssim.db.mysql.TextPropertyDAO;
import gssim.db.mysql.ApplicationPropertyDAO;
import gssim.db.mysql.UnitAllTimelineDAO;
import gssim.db.mysql.UnitDAO;
import gssim.db.mysql.UnitDetailsDAO;
import gssim.db.mysql.UnitEnTimelineDAO;
import gssim.db.mysql.UserDAO;

import java.net.MalformedURLException;

import javax.servlet.ServletContext;

/**
 * @author Mateusz Cichenski, Jarek Szymczak
 */
@BlazeDsDestination(swfHeight = "800", locales = {"en_US","pl_PL"}, names = {"GSSim Studio","GSSim Studio"}, descriptions = {"Application for GSSim job description","Aplikacja do generowania zada� dla symulatora GSSim"})
@PortletDisplayName(locales = {"en", "pl"}, values = {"GSSimStudio Application", "Aplikacja GSSimStudio"})
public class GSSimStudio extends DatabaseHelper implements ModelInitialization , FileUploadAccepter {
	
	private Boolean developement = true;

	private static MySQLDAOFactory factory;

	//FIXME: usunac to potem
	protected final static String resourceBoundle = "locale.grms3client";
	
	/**
	 * Logger instance for this class
	 */
    private ServiceLog log = ServiceLog.getInstance(GSSimStudio.class);
    
    @BlazeDsMethod()
    public GSSimStudioModel getOpenURL(String fileUrl) throws MalformedURLException {
    	GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
        FileLocation fileLocation = new FileLocation(fileUrl);
        ServletContext servletContext = FlexContext.getServletContext();
        String contentType = servletContext.getMimeType(fileLocation.getFileName().toLowerCase());
        log.debug("getOpenURL : contentType: " + contentType);
        String openUrl = null;
        if (contentType != null) {
            openUrl = VineFlexUtilClass.getURL(fileLocation, contentType);
        } else {
            openUrl = VineFlexUtilClass.getDownloadURL(fileLocation);
        }

        model.setOpenUrl(openUrl);
        return model;
    }
    
    @BlazeDsMethod()
	public GSSimStudioModel uploadAndSubmitExperiment(String destFileName, String fileContent) throws IOException {
		String expName = destFileName.split("_")[1].split(".properties")[0];
		String metaexpName = destFileName.split("_")[0];
		Integer expId = addExperimentToDb(expName, metaexpName);
		fileContent += "experiment.id="+expId.toString();
		uploadPropertyFile(destFileName, fileContent);
		
		UUID uuid = UUID.randomUUID();
		String uniqueFolderName = uuid.toString();
		
		String grmsURL = null;
		String grmsDN = null;
		String jobDescription = null;
		String inputLocation = null;
		String outputLocation = null;
		String gssimInput = null;
		
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			ApplicationPropertyDAO applicationPropertyDAO = factory.createApplicationProperty();
			Finder finder = Finder.getApplicationPropertyFinder(apServiceURL);
			List<ApplicationProperty> list = applicationPropertyDAO.find(finder);
			if (list.isEmpty()) ;
			else
				grmsURL = list.get(0).getValue();
			
			finder = Finder.getApplicationPropertyFinder(apServiceDN);
			list = applicationPropertyDAO.find(finder);
			if (list.isEmpty()) ;
			else
				grmsDN = list.get(0).getValue();
			
			finder = Finder.getApplicationPropertyFinder(apJobDescription);
			list = applicationPropertyDAO.find(finder);
			if (list.isEmpty()) ;
			else {
				jobDescription = list.get(0).getValue();
				jobDescription = jobDescription.replace(jdPropertyFile, uniqueFolderName + "/" + destFileName);
			}
			
			finder = Finder.getApplicationPropertyFinder(apInputLocation);
			list = applicationPropertyDAO.find(finder);
			if (list.isEmpty()) ;
			else {
				inputLocation = list.get(0).getValue();
				if (inputLocation.endsWith("/"))
					inputLocation = inputLocation.substring(0,inputLocation.length() - 1);
				if (jobDescription != null)
					jobDescription = jobDescription.replace(jdInputLocation, inputLocation);
			}
			
			finder = Finder.getApplicationPropertyFinder(apOutputLocation);
			list = applicationPropertyDAO.find(finder);
			if (list.isEmpty()) ;
			else {
				outputLocation = list.get(0).getValue();
				if (jobDescription != null)
					jobDescription = jobDescription.replace(jdOutputLocation, outputLocation);
			}
			
			finder = Finder.getApplicationPropertyFinder(apGSSimInput);
			list = applicationPropertyDAO.find(finder);
			if (list.isEmpty()) ;
			else
				gssimInput = list.get(0).getValue();
			
		} catch (SQLException e) {
			;
		} catch (InstantiationException e) {
			;		
		} catch (IllegalAccessException e) {
			;	
		} catch (ClassNotFoundException e) {
			;	
		} catch (Exception e) {
			;	
		} finally {
			closeConnection(connection, null);
		}
		
		//move the files to unique subfolder
		String[] cmd = new String[2];
		cmd[0] = "mkdir";
		cmd[1] = inputLocation + "/" + uniqueFolderName;
		Runtime.getRuntime().exec(cmd).waitFor();
		cmd = new String[3];
		cmd[0] = "cp";
		cmd[2] = inputLocation + "/" + uniqueFolderName;
		cmd[1] = gssimInput + "/" + destFileName;
		Runtime.getRuntime().exec(cmd).waitFor();
		
		return doSubmitApplication(grmsURL, grmsDN, jobDescription);
	}
    
	/* DB Methods */
	protected void getPluginsFromDb(GSSimStudioModel model) {
		Connection connection = null;
		
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			PluginDAO pluginDAO = factory.createPlugin();
			Finder finder = Finder.getPluginFinder(null, null, null);
			List<Plugin> list = pluginDAO.find(finder);
			
			PluginCompatibilityDAO compatibilityDAO = factory.createPluginCompatibility();
			Finder finderC = Finder.getPluginCompatibilityFinder(null, null);
			List<PluginCompatibility> listC = compatibilityDAO.find(finderC);
			HashMap<Integer, String> compatiblePlugins = new HashMap<Integer, String>();
			String allPluginIds = "-1";
			for (int i = 0; i < list.size(); i++)
			{
				//insert compatibility to "none" plugin
				compatiblePlugins.put(list.get(i).getPK(), "-1");
				allPluginIds += ","+list.get(i).getPK();
			}
			for (int i = 0; i < listC.size(); i++)
			{
				Integer parent = listC.get(i).getParentId();
				Integer child = listC.get(i).getChildId();
				String tmp = compatiblePlugins.get(parent);
				tmp += "," + child.toString();
				compatiblePlugins.put(parent, tmp);
				tmp = compatiblePlugins.get(child);
				tmp += "," + parent.toString();
				compatiblePlugins.put(child, tmp);
			}
			
			List<HashMap<String, String>> local = new ArrayList<HashMap<String, String>>();
			model.setLocalPluginList(local);
			List<HashMap<String, String>> global = new ArrayList<HashMap<String, String>>();
			model.setGlobalPluginList(global);
			
			HashMap<String, String> noneMap = new HashMap<String, String>();
			noneMap.put("label", "(...)");
			noneMap.put("id", "-1");
			noneMap.put("compatible", allPluginIds);
			global.add(noneMap);
			local.add(noneMap);
			
			for (int i = 0; i < list.size(); i++)
			{
				Plugin plugin = list.get(i);
				HashMap<String, String> pluginMap = new HashMap<String, String>();
				pluginMap.put("label", plugin.getName());
				pluginMap.put("data", plugin.getInput());
				pluginMap.put("description", plugin.getDescription());
				pluginMap.put("id", plugin.getPK().toString());
				pluginMap.put("compatible", compatiblePlugins.get(plugin.getPK()));
				if (plugin.getIsGlobal()) global.add(pluginMap);
				else local.add(pluginMap);
			}
			
			model.setError("");

		} catch (SQLException e) {
			setSqlError("Allocations", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}
	}
    
	@BlazeDsMethod()
	public GSSimStudioModel getAllocationsFromDb(Integer taskId, Integer unitId) {

		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		//avoid updating experiment list in archive when nothing changed
		model.setExperimentListChanged(false);
		Connection connection = null;
		
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			AllocationDAO allocationDAO = factory.createAllocation();
			Finder finder = Finder.getAllocationFinder(taskId, unitId);

			List<Allocation> list = allocationDAO.find(finder);

			model.setAllocationList(list);
			model.setError("");

		} catch (SQLException e) {
			setSqlError("Allocations", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;
	}

	@BlazeDsMethod()
	public GSSimStudioModel getAllocationDetailsFromDb(Integer allocationId) {

		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		//avoid updating experiment list in archive when nothing changed
		model.setExperimentListChanged(false);
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			AllocationDetailsDAO allocationDetailsDAO = factory
					.createAllocationDetails();
			Finder finder = Finder.getAllocationDetailsFinder(allocationId);

			List<AllocationDetails> list = allocationDetailsDAO.find(finder);

			model.setAllocationDetailsList(list);
			model.setError("");

		} catch (SQLException e) {
			setSqlError("Allocation details", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;
	}

	@BlazeDsMethod()
	public GSSimStudioModel getBlobPropertiesFromDb(Integer configId) {

		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		//avoid updating experiment list in archive when nothing changed
		model.setExperimentListChanged(false);
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			BlobPropertyDAO blobPropertyDAO = factory.createBlobProperty();
			Finder finder = Finder.getBlobPropertyFinder(configId);

			List<BlobProperty> list = blobPropertyDAO.find(finder);

			model.setBlobPropertyList(list);
			model.setError("");

		} catch (SQLException e) {
			setSqlError("Blob properties", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;
	}
	
	/**
	 * Used to get data for resource chart in network topology editor.
	 * 
	 * @param type a string representing the chart type - energy or allocation
	 * 
	 * This method is a copy of the method from ResourceChart.
	 * FIXME: some refactorization could be useful
	 */
	@BlazeDsMethod()
	public GSSimStudioModel getResourceTimelineFromDb(String resourceName, Integer expId, String type) {

		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			Timestamp minTimestamp = null;
			Timestamp maxTimestamp = null;
			
			ResourceDAO resDAO = factory.createResource();
			Finder resFinder = Finder.getResourceFinder(expId, resourceName, null);
			List<Resource> resList = resDAO.find(resFinder);
			if (resList.size() > 0)
			{
				Resource res = resList.get(0);
				if (type.equals("energy"))
				{
					ResourceEnTimelineDAO resourceDAO = factory
					.createResourceEnTimeline();

					Finder finder = Finder.getResourceAllocationTimelineFinder(res.getPK(), minTimestamp, maxTimestamp);
					List<ResourceEnTimeline> list = resourceDAO.find(finder);
		
					model.setResourceTimelineList(list);
				}
				if (type.equals("allocation"))
				{
					ResourceAllTimelineDAO resourceDAO = factory
					.createResourceAllTimeline();

					Finder finder = Finder.getResourceAllocationTimelineFinder(res.getPK(), minTimestamp, maxTimestamp);
					List<ResourceAllTimeline> list = resourceDAO.find(finder);
		
					model.setResourceTimelineList(list);
				}
			}

		} catch (SQLException e) {
			setSqlError("Resources allocation timeline", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;
	}
	
	@BlazeDsMethod()
	public GSSimStudioModel getExperimentConfiguration(List experiments) {

		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		//avoid updating experiment list in archive when nothing changed
		model.setExperimentListChanged(false);
		
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			
			ExperimentDAO experimentDAO = factory.createExperiment();
			
			HashMap result = new HashMap();
			
			for (int i = 0; i < experiments.size(); i++)
			{
				Experiment exp = new Experiment();
				exp.setPK((Integer)experiments.get(i));
				exp = experimentDAO.select(exp);
				
				TextPropertyDAO propertyDAO = factory.createTextProperty();
				Finder finder = Finder.getTextPropertyFinder(exp.getConfigId());

				List<TextProperty> list = propertyDAO.find(finder);
				HashMap<String, String> map = new HashMap<String, String>();
				for (int j = 0; j < list.size(); j++)
				{
					map.put(list.get(j).getName(), list.get(j).getValue());
				}
				map.put("name", exp.getName());
				map.put("pk", exp.getPK().toString());
				map.put("groupId", exp.getMetaexpId().toString());
				result.put(exp.getPK().toString(), map);
			}

			model.setExperimentsConfiguration(result);

		} catch (SQLException e) {
			setSqlError("Resources", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;
	}
	
	protected int addExperimentToDb(String expName, String metaexperiment) {
		Connection connection = null;
		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			
			ExperimentDAO experimentDAO = factory.createExperiment();
			UserDAO userDAO = factory.createUser();
			ConfigurationDAO configurationDAO = factory.createConfiguration();
			MetaexperimentDAO metaDAO = factory.createMetaexperiment();
			
			Experiment experiment = new Experiment();
			
			Configuration configuration = new Configuration();
			configurationDAO.insert(configuration, false);

			User user = new User();
			user.setDN("unknown_user");
			userDAO.insert(user, false);
			
			int metaId = getMetaexpId(metaDAO, metaexperiment);
			if (metaId == -1) metaId = addMetaexperiment(metaDAO, metaexperiment);
			
			experiment.setMetaexpId(metaId);
			experiment.setName(expName);
			experiment.setStatus("SUBMITTED");
			experiment.setConfigId(configuration.getId());
			experiment.setUserId(user.getId());
			Timestamp time = new Timestamp((new Date()).getTime());
			experiment.setCommissionDate(time);
			experimentDAO.insert(experiment, false);
			connection.commit();
			
			return experiment.getPK();
			
		} catch (SQLException e) {
			setSqlError("Experiments", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return -1;
	}
	
	/**
	 * Look for metaexperiment with the given name.
	 * 
	 */
	protected int getMetaexpId(MetaexperimentDAO metaDAO, String metaexpname) throws SQLException
	{
		List<Metaexperiment> list = metaDAO.find(Finder.getMetaexperimentFinder(metaexpname));
		if (list.size() == 1) return list.get(0).getId();
		return -1;
	}
	
	/**
	 * Add new metaexperiment with the given name.
	 */
	protected int addMetaexperiment(MetaexperimentDAO metaDAO, String metaexpname) throws SQLException
	{
		Metaexperiment meta = new Metaexperiment();
		meta.setName(metaexpname);
		metaDAO.insert(meta, false);
		return meta.getId();
	}
	
	/**
	 * Update metaexperiment lists
	 */
	protected void getMetaexperimentsFromDb(GSSimStudioModel model, String name) throws SQLException
	{
		MetaexperimentDAO metaDAO = factory.createMetaexperiment();
		Finder finder = Finder.getMetaexperimentFinder(name);

		List<Metaexperiment> list = metaDAO.find(finder);
		
		HashMap<Integer, String> map = new HashMap<Integer, String>();
		model.setMetaexperimentList(map);
		for (int i = 0; i < list.size(); i++)
		{
			map.put(list.get(i).getId(), list.get(i).getName());
			log.error("Hashmap logged "+i+" = " + list.get(i).getName());
		}
		
		model.setError("");
	}

	/**
	 * Delete experiment with the given key.
	 */
	protected void deleteExperiment(ExperimentDAO experimentDAO, Integer PK) throws SQLException
	{
		Experiment experiment = new Experiment();
		experiment.setPK(PK);
		experimentDAO.delete(experiment, false);
	}
	
	/**
	 * Change experiment with the given key.
	 * Factory needs to be initialized! [by appropriate connection]
	 */
	protected void updateExperiment(ExperimentDAO experimentDAO, Integer PK, Integer userID, Integer configID, String name, Timestamp commissionDate, String description, String status, Integer metaexpID) throws SQLException
	{
		Experiment experiment = new Experiment();
		experiment.setPK(PK);
		experiment = experimentDAO.select(experiment);
		if (userID != -1) experiment.setUserId(userID);
		if (configID != -1) experiment.setConfigId(configID);
		if (commissionDate != null) experiment.setCommissionDate(commissionDate);
		if (name != null) experiment.setName(name);
		if (description != null) experiment.setDescription(description);
		if (status != null) experiment.setStatus(status);
		if (metaexpID != -1) experiment.setMetaexpId(metaexpID);
		experimentDAO.update(experiment, false);
	}
	
	@BlazeDsMethod()
	public GSSimStudioModel deleteExperiment(Integer PK) {
		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		//avoid updating experiment list in archive when nothing changed
		model.setExperimentListChanged(false);
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			
			ExperimentDAO experimentDAO = factory.createExperiment();
			deleteExperiment(experimentDAO, PK);
			
			connection.commit();
			
		} catch (SQLException e) {
			setSqlError("Experiments", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}
		
		return getExperimentsFromDb(model, null, null, null);
	}
	
	@BlazeDsMethod()
	public GSSimStudioModel updateExperiment(Integer PK, Integer userID, Integer configID, String name, Timestamp commissionDate, String description, String status, Integer metaexpID) {
		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		//avoid updating experiment list in archive when nothing changed
		model.setExperimentListChanged(false);
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			
			ExperimentDAO experimentDAO = factory.createExperiment();
			
			updateExperiment(experimentDAO, PK, userID, configID, name, commissionDate, description, status, metaexpID);
			
			connection.commit();
			
		} catch (SQLException e) {
			setSqlError("Experiments", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}
		
		return getExperimentsFromDb(model, null, null, null);
	}
	
	@BlazeDsMethod()
	public GSSimStudioModel changeExperimentsMetaexperiment(List experiments, String metaexperiment) {
		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		//avoid updating experiment list in archive when nothing changed
		model.setExperimentListChanged(false);
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			
			ExperimentDAO experimentDAO = factory.createExperiment();
			MetaexperimentDAO metaDAO = factory.createMetaexperiment();
			
			int metaId = getMetaexpId(metaDAO, metaexperiment);
			if (metaId == -1) metaId = addMetaexperiment(metaDAO, metaexperiment);
			
			for (int i = 0; i < experiments.size(); i++)
			{
				updateExperiment(experimentDAO, (Integer) experiments.get(i), -1, -1, null, null, null, null, metaId);
			}
			
			connection.commit();
			
		} catch (SQLException e) {
			setSqlError("Experiments", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}
		
		return getExperimentsFromDb(model, null, null, null);
	}
	
	@BlazeDsMethod()
	public GSSimStudioModel getExperimentNetworkTopology(Integer PK) {
		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		//avoid updating experiment list in archive when nothing changed
		model.setExperimentListChanged(false);
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			
			ExperimentDAO experimentDAO = factory.createExperiment();
			Experiment experiment = new Experiment();
			experiment.setPK(PK);
			experiment = experimentDAO.select(experiment);
			
			BlobPropertyDAO blobDAO = factory.createBlobProperty();
			BlobProperty blob = new BlobProperty();
			blob.setConfigId(experiment.getConfigId());
			blob.setName(GSSimStudioConstants.NetworkTopologyBlobProperty);
			blob = blobDAO.select(blob);
			
			if (blob != null)
				model.setCurrentExperimentNetworkTopology(blob.getValue());
			else
				model.setCurrentExperimentNetworkTopology(null);
			
			model.setError("");

		} catch (SQLException e) {
			setSqlError("Experiments", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;
	}
	
	@BlazeDsMethod()
	public GSSimStudioModel getExperimentsFromDb(Integer userId,
			Boolean publish, String status) {
		return getExperimentsFromDb(null, userId, publish, status);
	}
	
	protected GSSimStudioModel getExperimentsFromDb(GSSimStudioModel model, Integer userId,
			Boolean publish, String status) {

		if (model == null) model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			
			getMetaexperimentsFromDb(model, null);
			
			ExperimentDAO experimentDAO = factory.createExperiment();
			Finder finder = Finder.getExperimentFinder(userId, null, null, null, null, status, null);

			List<Experiment> list = experimentDAO.find(finder);

			model.setExperimentList(list);
			model.setExperimentListChanged(true);
			model.setError("");

		} catch (SQLException e) {
			setSqlError("Experiments", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;
	}

	@BlazeDsMethod()
	public GSSimStudioModel getExperimentStatsFromDb(Integer experimentId) {

		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		//avoid updating experiment list in archive when nothing changed
		model.setExperimentListChanged(false);
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			ExperimentStatsDAO experimentStatsDAO = factory.createExperimentStats();
			Finder finder = Finder.getExperimentStatsFinder(experimentId);
			List<ExperimentStats> list = experimentStatsDAO.find(finder);

			model.setExperimentStatsList(list);
			model.setError("");

		} catch (SQLException e) {
			setSqlError("Experiment stats", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;
	}
	
	@BlazeDsMethod()
	public GSSimStudioModel getExtendedConfigurationFromDb(int id) {
		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		//avoid updating experiment list in archive when nothing changed
		model.setExperimentListChanged(false);
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			
			ExtendedConfiguration extendedConfiguration = new ExtendedConfiguration();
			
			ConfigurationDAO configurationDAO = factory.createConfiguration();

			Configuration configuration = new Configuration();
			configuration.setId(id);
			configuration = configurationDAO.select(configuration);
			
			if(configuration != null) {

				TextPropertyDAO textPropertyDAO = factory.createTextProperty();
				Finder finder = Finder.getTextPropertyFinder(configuration.getId());
	
				List<TextProperty> textPropertyList = textPropertyDAO.find(finder);
				
				BlobPropertyDAO blobPropertyDAO = factory.createBlobProperty();
				finder = Finder.getBlobPropertyFinder(configuration.getId());

				List<BlobProperty> blobPropertyList = blobPropertyDAO.find(finder);
				
				extendedConfiguration.setConfigurationId(configuration.getId());
				extendedConfiguration.setTextPropertyList(textPropertyList);
				extendedConfiguration.setBlobPropertyList(blobPropertyList);
				
				BlobProperty networkTopologyBlob = new BlobProperty();
				networkTopologyBlob.setConfigId(configuration.getId());
				networkTopologyBlob.setName("Network topology");
				networkTopologyBlob = blobPropertyDAO.select(networkTopologyBlob);
				
				String networkTopology = new String(networkTopologyBlob.getValue(), "utf-8");
				extendedConfiguration.setNetworkTopology(networkTopology);
			
				model.setExtendedConfiguration(extendedConfiguration);
			}
			
			model.setError("");

		} catch (SQLException e) {
			setSqlError("Configuration", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;

	}	

	@BlazeDsMethod()
	public GSSimStudioModel getQueuesFromDb(Integer resourceId) {

		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		//avoid updating experiment list in archive when nothing changed
		model.setExperimentListChanged(false);
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			QueuesDAO queuesDAO = factory.createQueues();
			Finder finder = Finder.getQueuesFinder(resourceId);

			List<Queues> list = queuesDAO.find(finder);

			model.setQueuesList(list);
			model.setError("");

		} catch (SQLException e) {
			setSqlError("Queueus", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;
	}

	@BlazeDsMethod()
	public GSSimStudioModel getReservationsFromDb(Integer taskId, Integer unitId) {

		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		//avoid updating experiment list in archive when nothing changed
		model.setExperimentListChanged(false);
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			ReservationDAO ReservationDAO = factory.createReservation();
			Finder finder = Finder.getReservationFinder(taskId, unitId);

			List<Reservation> list = ReservationDAO.find(finder);

			model.setReservationList(list);
			model.setError("");

		} catch (SQLException e) {
			setSqlError("Reservations", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;
	}

	@BlazeDsMethod()
	public GSSimStudioModel getReservationDetailsFromDb(Integer reservationId) {

		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		//avoid updating experiment list in archive when nothing changed
		model.setExperimentListChanged(false);
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			ReservationDetailsDAO reservationDetailsDAO = factory
					.createReservationDetails();
			Finder finder = Finder.getReservationDetailsFinder(reservationId);

			List<ReservationDetails> list = reservationDetailsDAO.find(finder);

			model.setReservationDetailsList(list);
			model.setError("");

		} catch (SQLException e) {
			setSqlError("Reservation details", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;
	}

	@BlazeDsMethod()
	public GSSimStudioModel setSelectedResourceIndex(int index, Integer res) {
		return delegateResource(new Object[]{res}, index);
	}
	
	@BlazeDsMethod()
	public GSSimStudioModel getResourcesFromDb(int index, Integer expId, String name,
			String type) {
		return delegateResource(new Object[]{expId, name, type}, index);
	}
	
	@BlazeDsMethod()
	public GSSimStudioModel getResourceAllTimelineFromDb(int index, Integer resourceId, Integer expId,
			Long minTimestampMilis, Long maxTimestampMilis) {
		return delegateResource(new Object[]{resourceId, expId, minTimestampMilis, maxTimestampMilis}, index);
	}

	@BlazeDsMethod()
	public GSSimStudioModel getResourceEnTimelineFromDb(int index, Integer resourceId, Integer expId,
			Long minTimestampMilis, Long maxTimestampMilis) {
		return delegateResource(new Object[]{resourceId, expId, minTimestampMilis, maxTimestampMilis}, index);
	}
	
	@BlazeDsMethod()
	public GSSimStudioModel getExperimentConfiguration(int index, Integer expId) {
		return delegateResource(new Object[]{expId}, index);
	}
	
	protected GSSimStudioModel delegateResource(Object[] parameters, Integer index) {
		GSSimStudioModel gssimStudioModel = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		gssimStudioModel.setExperimentListChanged(false);
        ResourceChartModel resourceChartModel = (ResourceChartModel) gssimStudioModel.getResourceChartComponents().get(index.toString());
        if (resourceChartModel == null)
        {
        	resourceChartModel = new ResourceChartModel();
        	gssimStudioModel.getResourceChartComponents().put(index.toString(), resourceChartModel);
        }
        VineFlexUtilClass.invokeDestination(ResourceChart.class, parameters, resourceChartModel);
        return gssimStudioModel;
    }
	
	@BlazeDsMethod()
	public GSSimStudioModel getComparisonFromDb(int index, List experiments, List parameters) {
		return delegateComparison(new Object[]{experiments, parameters}, index);
	}
	
	@BlazeDsMethod()
	public GSSimStudioModel getCategoryComparisonFromDb(int index, List experiments, List parameters) {
		return delegateComparison(new Object[]{experiments, parameters}, index);
	}

	protected GSSimStudioModel delegateComparison(Object[] parameters, Integer index) {
		GSSimStudioModel gssimStudioModel = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		gssimStudioModel.setExperimentListChanged(false);
		ExperimentComparisonChartModel experimentComparisonChartModel = (ExperimentComparisonChartModel) gssimStudioModel.getComparisonComponents().get(index.toString());
        if (experimentComparisonChartModel == null)
        {
        	experimentComparisonChartModel = new ExperimentComparisonChartModel();
        	gssimStudioModel.getComparisonComponents().put(index.toString(), experimentComparisonChartModel);
        }
        VineFlexUtilClass.invokeDestination(ExperimentComparisonChart.class, parameters, experimentComparisonChartModel);
        return gssimStudioModel;
    }
	
	@BlazeDsMethod()
	public GSSimStudioModel getTasksAllocationsFromDb(int index, Integer expId) {
		return delegateGannt(new Object[]{expId}, index);
	}
	
	protected GSSimStudioModel delegateGannt(Object[] parameters, Integer index) {
		GSSimStudioModel gssimStudioModel = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		gssimStudioModel.setExperimentListChanged(false);
        GanntChartModel ganntChartModel = (GanntChartModel) gssimStudioModel.getGanntChartComponents().get(index.toString());
        if (ganntChartModel == null)
        {
        	ganntChartModel = new GanntChartModel();
        	gssimStudioModel.getGanntChartComponents().put(index.toString(), ganntChartModel);
        }
        VineFlexUtilClass.invokeDestination(GanntChart.class, parameters, ganntChartModel);
        return gssimStudioModel;
    }
	
	@BlazeDsMethod()
	public GSSimStudioModel getTasksFromDb(Integer type, Integer expId,
			Integer jobId, Integer taskId, Integer procSetId) {

		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		//avoid updating experiment list in archive when nothing changed
		model.setExperimentListChanged(false);
		Connection connection = null;
		try {

			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);

			TaskDAO taskDAO = factory.createTask();
			Finder finder = Finder.getTaskFinder(expId, jobId, taskId,
					procSetId);

			TaskDAO.Type taskType = null;

			if(type != null)
			{
				switch (type) {
				case 0:
					taskType = TaskDAO.Type.JOB;
					break;
				case 1:
					taskType = TaskDAO.Type.TASK;
					break;
				case 2:
					taskType = TaskDAO.Type.PROCESS_SET;
					break;
				default:
					taskType = null;
				}
			}

			List<Task> list;

			if (taskType == null)
				list = taskDAO.find(finder);
			else
				list = taskDAO.find(finder, taskType);

			model.setTaskList(list);
			model.setError("");

		} catch (SQLException e) {
			setSqlError("Tasks", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;
	}

	@BlazeDsMethod()
	public GSSimStudioModel getTasksFromDb(Integer type, Integer expId, Integer jobId,
			Integer taskId, Integer procSetId, Long minExecutionStartDateMilis,
			Long maxExecutionStartDateMilis, Long minExecutionFinishDateMilis,
			Long maxExecutionFinishDateMilis) {

		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		//avoid updating experiment list in archive when nothing changed
		model.setExperimentListChanged(false);
		Connection connection = null;
		try {

			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);

			TaskDAO taskDAO = factory.createTask();

			Timestamp minExecutionStartDate = minExecutionStartDateMilis == null ? null
					: new Timestamp(minExecutionStartDateMilis);
			Timestamp maxExecutionStartDate = maxExecutionStartDateMilis == null ? null
					: new Timestamp(maxExecutionStartDateMilis);
			Timestamp minExecutionFinishDate = minExecutionFinishDateMilis == null ? null
					: new Timestamp(minExecutionFinishDateMilis);
			Timestamp maxExecutionFinishDate = maxExecutionFinishDateMilis == null ? null
					: new Timestamp(maxExecutionFinishDateMilis);

			Finder finder = Finder.getTaskFinder(expId, jobId, taskId,
					procSetId, minExecutionStartDate, maxExecutionStartDate,
					minExecutionFinishDate, maxExecutionFinishDate);

			TaskDAO.Type taskType = null;

			switch (type) {
			case 0:
				taskType = TaskDAO.Type.JOB;
				break;
			case 1:
				taskType = TaskDAO.Type.TASK;
				break;
			case 2:
				taskType = TaskDAO.Type.PROCESS_SET;
				break;
			default:
				taskType = null;
			}

			List<Task> list;

			if (taskType == null)
				list = taskDAO.find(finder);
			else
				list = taskDAO.find(finder, taskType);

			model.setTaskList(list);
			model.setError("");

		} catch (SQLException e) {
			setSqlError("Tasks", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;
	}
	
	@BlazeDsMethod()
	public GSSimStudioModel getTextPropertiesFromDb(Integer configId) {

		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		//avoid updating experiment list in archive when nothing changed
		model.setExperimentListChanged(false);
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			TextPropertyDAO textPropertyDAO = factory.createTextProperty();
			Finder finder = Finder.getTextPropertyFinder(configId);

			List<TextProperty> list = textPropertyDAO.find(finder);

			model.setTextPropertyList(list);
			model.setError("");

		} catch (SQLException e) {
			setSqlError("Text properties", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;
	}
	
	@BlazeDsMethod()
	public GSSimStudioModel getUnitsFromDb(Integer resourceId, String name,
			String type) {

		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		//avoid updating experiment list in archive when nothing changed
		model.setExperimentListChanged(false);
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			UnitDAO unitDAO = factory.createUnit();
			Finder finder = Finder.getUnitFinder(resourceId, name, type);

			List<Unit> list = unitDAO.find(finder);

			model.setUnitList(list);
			model.setError("");

		} catch (SQLException e) {
			setSqlError("Units", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;
	}
	
	@BlazeDsMethod()
	public GSSimStudioModel getUnitAllTimelineFromDb(Integer unitId,
			Long minTimestampMilis, Long maxTimestampMilis) {

		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		//avoid updating experiment list in archive when nothing changed
		model.setExperimentListChanged(false);
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			UnitAllTimelineDAO unitDAO = factory.createUnitAllTimeline();

			Timestamp minTimestamp = minTimestampMilis == null ? null
					: new Timestamp(minTimestampMilis);
			Timestamp maxTimestamp = maxTimestampMilis == null ? null
					: new Timestamp(maxTimestampMilis);

			Finder finder = Finder.getUnitAllocationTimelineFinder(unitId,
					minTimestamp, maxTimestamp);

			List<UnitAllTimeline> list = unitDAO.find(finder);

			model.setUnitAllTimelineList(list);
			model.setError("");

		} catch (SQLException e) {
			setSqlError("Unit allocation timeline", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;
	}

	@BlazeDsMethod()
	public GSSimStudioModel getUnitDetailsFromDb(Integer unitId) {

		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		//avoid updating experiment list in archive when nothing changed
		model.setExperimentListChanged(false);
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			UnitDetailsDAO unitDetailsDAO = factory
					.createUnitDetails();
			Finder finder = Finder.getUnitDetailsFinder(unitId);

			List<UnitDetails> list = unitDetailsDAO.find(finder);

			model.setUnitDetailsList(list);
			model.setError("");

		} catch (SQLException e) {
			setSqlError("Unit details", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;
	}	
	
	@BlazeDsMethod()
	public GSSimStudioModel getUnitEnTimelineFromDb(Integer unitId,
			Long minTimestampMilis, Long maxTimestampMilis) {

		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		//avoid updating experiment list in archive when nothing changed
		model.setExperimentListChanged(false);
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			UnitEnTimelineDAO unitDAO = factory.createUnitEnTimeline();

			Timestamp minTimestamp = minTimestampMilis == null ? null
					: new Timestamp(minTimestampMilis);
			Timestamp maxTimestamp = maxTimestampMilis == null ? null
					: new Timestamp(maxTimestampMilis);

			Finder finder = Finder.getUnitAllocationTimelineFinder(unitId,
					minTimestamp, maxTimestamp);

			List<UnitEnTimeline> list = unitDAO.find(finder);

			model.setUnitEnTimelineList(list);
			model.setError("");

		} catch (SQLException e) {
			setSqlError("Unit energy timeline", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;
	}

	public GSSimStudioModel getUser(int id) {
		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			UserDAO userDAO = factory.createUser();

			User user = new User();
			user.setId(id);
			user = userDAO.select(user);

			model.setUser(user);
			model.setError("");

		} catch (SQLException e) {
			setSqlError("User", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;

	}	
	
	private void closeConnection(Connection connection, GSSimStudioModel model) {
		String error = null;
		if (model != null)
			error = model.getError();
		
		if (connection != null)
			try {
				connection.close();
			} catch (SQLException e) {
				if (error == null || error.equals("")) {
					error = "Error while trying to close the SQL connection";
				} else {
					error += System.getProperty("line.separator");
					error += "Error while trying to close the SQL connection";
				}
			}

		if (model != null)
			model.setError(error);
	}

	private void setSqlError(String name, GSSimStudioModel model, Exception e) {
		setError(name + ": an SQL exception occured while trying retrieve data from database", model, e);
	}
	
	private void setDbConnectionError(GSSimStudioModel model, Exception e) {
		setError("An exception occured while trying to create MySQLDAOFactory", model, e);
	}
	
	private void setError(String messageForUser, GSSimStudioModel model, Exception e) {
		
		String error = messageForUser;
		
		if(developement)
		{
			error += System.getProperty("line.separator");
			error += "Error details:";
			error += System.getProperty("line.separator");
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			PrintStream ps = new PrintStream(baos);
			e.printStackTrace(ps);
			String stackTrace = baos.toString();		
			error += stackTrace;
		}
		
		model.setError(error);
	}			
	
	private MySQLDAOFactory factory() throws InstantiationException, IllegalAccessException, ClassNotFoundException {
		if(factory == null)
			factory = new MySQLDAOFactory();
		return factory;
	}
	/* END OF DB Methods */
	
	
	/*******************/
	/** GRMS3 Methods **/
	/*******************/
	
	/**
	 * Submit new GRMS job to the server. Job is described by XML structure,
	 * which defines what application should be runned, what arguments
	 * should be passed and where to store the resulting output.
	 * 
	 * @param grmsURL			address of GRMS server
	 * @param grmsDN			DN of GRMS server
	 * @param jobDescription	formatted XML text with the job description
	 */
	@BlazeDsMethod()
	public GSSimStudioModel doSubmitApplication(String grmsURL, String grmsDN, String jobDescription) {

		log.debug(jobDescription);
		
		GSSimStudioModel model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		model.setGrmsDN(grmsDN);
		model.setGrmsURL(grmsURL);
		//avoid updating experiment list in archive when nothing changed
		model.setExperimentListChanged(true);

		GRMS3Job grms3job = null;
		try {
			grms3job = callGRMS3SubmitJob(jobDescription, grmsDN, grmsURL);
		} catch (Exception e) {
			model.setErrorDescription(VineFlexUtilClass.getResourceString(resourceBoundle, "grms3.jobnotsubmitted")
					+ e.getMessage());
		}
		if ((grms3job == null) && (model.getErrorDescription() == null)) {
			model.setErrorDescription(VineFlexUtilClass.getResourceString(resourceBoundle, "grms3.jobnotsubmittedcauseunknown"));
		}

		if (grms3job != null) {
			//here we can get info about submitted job
			
			//gRMS3ClientModel.setSubmittedJob(grms3job);
			//gRMS3ClientModel.setJobDescription(grms3job.getDescription());
		}
		return doGetJobList(grmsURL, grmsDN, model, 0, 5);
	}
	
	/**
	 * Get the list of already submitted jobs on GRMS server.
	 * 
	 * @param grmsURL			address of GRMS server
	 * @param grmsDN			DN of GRMS server
	 * @param model				GSSimStudioModel used to transfer data with RIA
	 * @param jobFrom			which job should be picked first - job with ID 0 is the latest submitted job
	 * @param jobCount			how many jobs should be listed
	 */
	public GSSimStudioModel doGetJobList(String grmsURL, String grmsDN, GSSimStudioModel model, int jobFrom,
			int jobCount) {
		if (model == null) {
			model = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
		}
		GRMS3ReturnType grms3ReturnType = null;
		model.setGrmsDN(grmsDN);
		model.setGrmsURL(grmsURL);
		
		try {
			grms3ReturnType = callGRMS3GetJoblist(jobFrom, jobCount, grmsDN,
					grmsURL);
		} catch (Exception e) {
			model.setErrorDescription(VineFlexUtilClass.getResourceString(resourceBoundle, "grms3.cannotgetjoblist")
					+ e.getMessage());
		}
		if ((grms3ReturnType == null)
				&& (model.getErrorDescription() == null)) {
			model
					.setErrorDescription(VineFlexUtilClass.getResourceString(resourceBoundle, "grms3.cannotgetjoblistcauseunknown"));
		}
		if (grms3ReturnType != null) {
			List<GRMS3Job> grms3jobs = grms3ReturnType.getChildren();
			//gRMS3ClientModel.setJobCount(grms3ReturnType.getJobCount());
			//gRMS3ClientModel.setJobList(grms3jobs);
		}
		return model;
	}
	
	/**
	 * Calls SubmitJob on GRMS server.
	 */
	protected GRMS3Job callGRMS3SubmitJob(String jobDescription, String grmsDN,
			String grmsURL) throws Exception {
		GRMS3ClientModule gRMS3ClientModule = getGRMS3ClientModule(VineFlexUtilClass
				.getServiceContext());
		GRMS3Job gRMS3ClientJob = gRMS3ClientModule.submitJob(jobDescription,
				grmsDN, grmsURL);
		return gRMS3ClientJob;
	}

	/**
	 * Calls GetJoblist on GRMS server.
	 */
	protected GRMS3ReturnType callGRMS3GetJoblist(int jobFrom, int jobCount,
			String grmsDN, String grmsURL) throws Exception {
		GRMS3ClientModule gRMS3ClientModule = getGRMS3ClientModule(VineFlexUtilClass
				.getServiceContext());

		return gRMS3ClientModule.getJobList(jobFrom, jobCount, grmsDN, grmsURL);
	}
	
	/**
	 * Loads GRMS Client Module from resources, which is used to connect to GRMS server. 
	 */
	protected GRMS3ClientModule getGRMS3ClientModule(
			ServiceContext serviceContext) {
		ResourceManager rm = serviceContext.createResourceManager();
		List GRMS3ClientResourceList = rm
				.getResourcesByType(GRMS3ClientResource.KEY);
		if (GRMS3ClientResourceList.size() > 0) {
			log.debug("getGRMS3ClientModule: GRMS3ClientResourceList len: "
					+ GRMS3ClientResourceList.size());

			GRMS3ClientResource gRMS3ClientResource = (GRMS3ClientResource) GRMS3ClientResourceList
					.get(0);
			return (GRMS3ClientModule) gRMS3ClientResource
					.createResourceModule(GRMS3ClientModule.KEY, serviceContext);
		} else {
			log.error("getGRMS3ClientModule: no " + GRMS3ClientResource.KEY
					+ " found in domain.xml");
			return null;
		}
	}
	/**************************/
	/** END OF GRMS3 Methods **/
	/**************************/
	
	/*****************************/
	/** FILE MANAGEMENT Methods **/
	/*****************************/
	
	@BlazeDsMethod()
	public GSSimStudioModel allWorkloadFilesUploaded() throws IOException {
		return allFilesUploaded("gssim/input/workloads/");
	}
	
	@BlazeDsMethod()
	public GSSimStudioModel allTopologiesFilesUploaded() throws IOException {
		return allFilesUploaded("gssim/input/topologies/");
	}
	
	@BlazeDsMethod()
	public GSSimStudioModel allResourcesFilesUploaded() throws IOException {
		return allFilesUploaded("gssim/input/resources/");
	}
	
	@BlazeDsMethod()
    public GSSimStudioModel allFilesUploaded(String destinationPath) throws IOException {

        log.debug("FILELISTCOM all files uploaded");

        GSSimStudioModel fileListComModel = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
        Vector<FileItem> uploadedFiles = VineFlexUtilClass.getUploadedFiles();
        //avoid updating experiment list in archive when nothing changed
        fileListComModel.setExperimentListChanged(false);

        int numOfFiles = uploadedFiles.size();
        System.out.println("FILELISTCOM all files uploaded");
        

        //String workflowName = uploadedFiles.get(0).getName();

        ServiceContext serviceContext = VineFlexUtilClass.getServiceContext();

        FileResourceManager fileResourceManager = getFileResourceManager(serviceContext);

        Location resourceLocation = new Location((String) fileListComModel.getCurrentLocationItem().get("url"));

        FileManager fileManager = fileResourceManager.createFileManager(resourceLocation);

        //FileSystemManager portalFileSystemManager = VineFlexUtilClass.getPortalFileSystemManager();

        fileManager.changeDirectory((String) fileListComModel.getCurrentLocationItem().get("real_path"));

        Vector<FileItem> filesList = new Vector();
        for (int a = 0; a < numOfFiles; a++) {
        	filesList.add(uploadedFiles.get(a));
        }
        if (fileManager instanceof FileSystemManager) {
            for (int i = 0; i < numOfFiles; i++) {
            	int index = uploadedFiles.indexOf(filesList.get(i));
            	if(index > -1){
            		String targetpath = (String) fileListComModel.getCurrentLocationItem().get("path");
                	//targetpath += uploadedFiles.get(i).getName();
                    targetpath += filesList.get(i).getName();
                    if (targetpath.startsWith("/")) {
                        targetpath = targetpath.substring(1);
                    }
                    boolean tmp = VineFlexUtilClass.moveFileItemToPortalFileSystem(uploadedFiles, index, targetpath);
                    log.debug("move to portal file system result " + tmp);
            	}
            }
        } else {
            FileSystemManager portalFileSystemManager = VineFlexUtilClass.getPortalFileSystemManager();

            String tmpDir = "tmp" + String.valueOf(new Date().getTime());

            String realTmpDir = portalFileSystemManager.getRealPath(tmpDir);

            TaskMonitor tm = portalFileSystemManager.makeDirectory(tmpDir, TaskOptions.block());

            if (!tm.completed()) {
                throw new TaskException("error making tmp dir");
            }

            for (int i = 0; i < numOfFiles; i++) {
            	int index = uploadedFiles.indexOf(filesList.get(i));
            	if(index > -1){
            		//String fileName = uploadedFiles.get(i).getName();
            		String fileName = filesList.get(i).getName();
            		String targetPath = tmpDir + "/" + fileName;
            		boolean tmp = VineFlexUtilClass.moveFileItemToPortalFileSystem(uploadedFiles, index, targetPath);
            		if (tmp) {
            			try {
            				String tmpTargetPath = targetPath.replace(tmpDir, realTmpDir);
            				//log.debug("!!! src"+tmpTargetPath);
            				//targetLocation.setFileName(fileName);
            				String destPath = (String) fileListComModel.getCurrentLocationItem().get("path") + destinationPath;
            				if (destPath.endsWith("/")) {
            					destPath += fileName;
            				} else {
            					destPath += "/" + fileName;
            				}
            				FileLocation targetLocation = new FileLocation();
            				targetLocation.setQueryItem(FileLocation.QUERY_ITEM_FILE_PATH, destPath);
            				//log.debug("!!!!!! dest"+destPath);
            				TaskMonitor tmpTaskMon = fileManager.upload(tmpTargetPath, targetLocation, TaskOptions.block());
            				//log.debug("!!! called upload");
            				if (tmpTaskMon.completed()) {
            					log.debug("allFilesUploaded() upload successful");
            				} else if (tmpTaskMon.failed()) {
            					log.debug("allFilesUploaded() upload failed");
            				} else {
            					log.debug("allFilesUploaded() upload unexpected status");
            				}
            			} catch (Throwable e) {
            				log.debug("allFilesUploaded() " + e.getMessage());
            				log.debug("allFilesUploaded() " + e.getClass().getName());
            			} finally {
            			}

            		}
            		//log.debug("move to portal file system temp result "+tmp);
            	}
            }
            
            //clean up temporary folder
            final FileLocation tmpLocation = portalFileSystemManager.createDirLocation(tmpDir);
			log.debug("!!!!!" + tmpLocation.getUrl());
			FileSet delSet = new FileLocationSet(new ArrayList<FileLocation>() {
				{
					add(tmpLocation);
				}
			});
			TaskMonitor delMon = portalFileSystemManager.delete(delSet, TaskOptions.block());
			if (delMon.completed()) {
				log.debug("!!!!! tmp dir was deleted");
			} else {
				log.debug("!!!!! tmp dir was NOT deleted");
			}
        }
        ///MOJE

        //create workflow directory structure

        //ServiceContext serviceContext = VineFlexUtilClass.getServiceContext();

        //FileResourceManager fileResourceManager = getFileResourceManager(serviceContext);

        loadFileLocationItems(fileListComModel, fileResourceManager, (String) fileListComModel.getCurrentLocationItem().get("url"));
        //listWorkflows(workflowManagerAppModel);

        return fileListComModel;
    }
	
    public GSSimStudioModel uploadTextFile(String destFileName, String destFolder, String fileContent) throws IOException {

        log.debug("FILELISTCOM all files uploaded");

        GSSimStudioModel fileListComModel = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
        //avoid updating experiment list in archive when nothing changed
		fileListComModel.setExperimentListChanged(false);
        Vector<FileItem> uploadedFiles = new Vector<FileItem>();
		File rootDir = new File(System.getProperty("java.io.tmpdir"));
		FileItem item = new DiskFileItem("fieldName", null, false, destFileName, 10*1000*1000, rootDir);
		OutputStreamWriter writer = new OutputStreamWriter(item.getOutputStream());
		writer.write(fileContent, 0, fileContent.length());
		writer.close();
		uploadedFiles.add(item);

        int numOfFiles = uploadedFiles.size();
        System.out.println("FILELISTCOM all files uploaded");
        ServiceContext serviceContext = VineFlexUtilClass.getServiceContext();
        FileResourceManager fileResourceManager = getFileResourceManager(serviceContext);
        Location resourceLocation = new Location((String) fileListComModel.getCurrentLocationItem().get("url"));
        FileManager fileManager = fileResourceManager.createFileManager(resourceLocation);
        fileManager.changeDirectory((String) fileListComModel.getCurrentLocationItem().get("real_path"));

        Vector<FileItem> filesList = new Vector();
        for (int a = 0; a < numOfFiles; a++) {
        	filesList.add(uploadedFiles.get(a));
        }
        if (fileManager instanceof FileSystemManager) {
            for (int i = 0; i < numOfFiles; i++) {
            	int index = uploadedFiles.indexOf(filesList.get(i));
            	if(index > -1){
            		String targetpath = (String) fileListComModel.getCurrentLocationItem().get("path");
                    targetpath += filesList.get(i).getName();
                    if (targetpath.startsWith("/")) {
                        targetpath = targetpath.substring(1);
                    }
                    boolean tmp = VineFlexUtilClass.moveFileItemToPortalFileSystem(uploadedFiles, index, targetpath);
                    log.debug("move to portal file system result " + tmp);
            	}
            }
        } else {
            FileSystemManager portalFileSystemManager = VineFlexUtilClass.getPortalFileSystemManager();

            String tmpDir = "tmp" + String.valueOf(new Date().getTime());

            String realTmpDir = portalFileSystemManager.getRealPath(tmpDir);

            TaskMonitor tm = portalFileSystemManager.makeDirectory(tmpDir, TaskOptions.block());

            if (!tm.completed()) {
                throw new TaskException("error making tmp dir");
            }

            for (int i = 0; i < numOfFiles; i++) {
            	int index = uploadedFiles.indexOf(filesList.get(i));
            	if(index > -1){
            		String fileName = filesList.get(i).getName();
            		String targetPath = tmpDir + "/" + fileName;
            		boolean tmp = VineFlexUtilClass.moveFileItemToPortalFileSystem(uploadedFiles, i, targetPath);
            		if (tmp) {
            			try {
            				String tmpTargetPath = targetPath.replace(tmpDir, realTmpDir);
            				String destPath = (String) fileListComModel.getCurrentLocationItem().get("path") + "gssim/input/" + destFolder;
            				if (destPath.endsWith("/")) {
            					destPath += fileName;
            				} else {
            					destPath += "/" + fileName;
            				}
            				FileLocation targetLocation = new FileLocation();
            				targetLocation.setQueryItem(FileLocation.QUERY_ITEM_FILE_PATH, destPath);
            				TaskMonitor tmpTaskMon = fileManager.upload(tmpTargetPath, targetLocation, TaskOptions.block());
            				if (tmpTaskMon.completed()) {
            					log.debug("allFilesUploaded() upload successful");
            				} else if (tmpTaskMon.failed()) {
            					log.debug("allFilesUploaded() upload failed");
            				} else {
            					log.debug("allFilesUploaded() upload unexpected status");
            				}
            			} catch (Throwable e) {
            				log.debug("allFilesUploaded() " + e.getMessage());
            				log.debug("allFilesUploaded() " + e.getClass().getName());
            			} finally {
            				final FileLocation tmpLocation = portalFileSystemManager.createDirLocation(tmpDir);
            				log.debug("!!!!!" + tmpLocation.getUrl());
            				FileSet delSet = new FileLocationSet(new ArrayList<FileLocation>() {
            					{
            						add(tmpLocation);
            					}
            				});
            				TaskMonitor delMon = portalFileSystemManager.delete(delSet, TaskOptions.block());
            				if (delMon.completed()) {
            					log.debug("!!!!! tmp dir was deleted");
            				} else {
            					log.debug("!!!!! tmp dir was NOT deleted");
            				}

            			}

            		}
            	}
            }
        }
        
        loadFileLocationItems(fileListComModel, fileResourceManager, (String) fileListComModel.getCurrentLocationItem().get("url"));

        return fileListComModel;
    }
	
	@BlazeDsMethod()
    public GSSimStudioModel uploadPropertyFile(String destFileName, String fileContent) throws IOException {
		return uploadTextFile(destFileName, "", fileContent);
    }
	
	@BlazeDsMethod()
    public GSSimStudioModel uploadNetworkTopologyFile(String destFileName, String fileContent) throws IOException {
		return uploadTextFile(destFileName, "topologies/", fileContent);
    }
	
	@BlazeDsMethod()
    public GSSimStudioModel uploadResourceFile(String destFileName, String fileContent) throws IOException {
		return uploadTextFile(destFileName, "resources/", fileContent);
    }
	
	public void loadFileLocationItems(GSSimStudioModel fileListComModel, FileManager fileManager, String fileLocationUrl) throws IOException {

        log.debug("loadFileLocationItems " + fileLocationUrl);
        
        String url = "gsiftp://gssim.man.poznan.pl:2811/usr/local/admin/gssim/input/workloads/?filetype=directory";
        
        // Create file location for url
        FileLocation folderLocation = new FileLocation(url);

        // Change location
        //todo tu jest lipa
        fileManager.changeLocation(folderLocation);

        // List workload files
        ArrayList<HashMap> fileLocationItemList = new ArrayList<HashMap>();
        fileListComModel.setWorkloadFileLocationItemList(fileLocationItemList);
        loadFileLocationItemsForCurrentLocation(fileListComModel, fileManager, fileLocationItemList);
        
      //List topology files
        url = "gsiftp://gssim.man.poznan.pl:2811/usr/local/admin/gssim/input/topologies/?filetype=directory";
        folderLocation = new FileLocation(url);
        fileManager.changeLocation(folderLocation);
        fileLocationItemList = new ArrayList<HashMap>();
        fileListComModel.setTopologiesFileLocationItemList(fileLocationItemList);
        loadFileLocationItemsForCurrentLocation(fileListComModel, fileManager, fileLocationItemList);
        
        //List resource files
        url = "gsiftp://gssim.man.poznan.pl:2811/usr/local/admin/gssim/input/resources/?filetype=directory";
        folderLocation = new FileLocation(url);
        fileManager.changeLocation(folderLocation);
        fileLocationItemList = new ArrayList<HashMap>();
        fileListComModel.setResourcesFileLocationItemList(fileLocationItemList);
        loadFileLocationItemsForCurrentLocation(fileListComModel, fileManager, fileLocationItemList);
        
        //reset current location
        url = "gsiftp://gssim.man.poznan.pl:2811/usr/local/admin/?filetype=directory";
        folderLocation = new FileLocation(url);
        fileManager.changeLocation(folderLocation);
        HashMap<String, String> currentLocationItem = new HashMap<String, String>();
        fileListComModel.setCurrentLocationItem(currentLocationItem);
        currentLocationItem.put("real_path", folderLocation.getFilePath());
        currentLocationItem.put("path", fileManager.getCurrentDirectory());
        currentLocationItem.put("url", folderLocation.getUrl());
        currentLocationItem.put("downloadUrl", VineFlexUtilClass.getDownloadURL(folderLocation));
    }

    public void loadFileLocationItems(GSSimStudioModel fileListComModel, FileResourceManager fileResourceManager, String fileLocationUrl) throws IOException {
        log.debug("loadFileLocationItems" + fileLocationUrl);

        String url = "gsiftp://gssim.man.poznan.pl:2811/usr/local/admin/gssim/input/workloads/?filetype=directory";
        
        // Create file location for url
        FileLocation folderLocation = new FileLocation(url);

        // Get file manager for given location
        //TODO: nie dziala dla gria
        FileManager fileManager = fileResourceManager.createFileManager(folderLocation);

        // List workload files
        ArrayList<HashMap> fileLocationItemList = new ArrayList<HashMap>();
        fileListComModel.setWorkloadFileLocationItemList(fileLocationItemList);
        loadFileLocationItemsForCurrentLocation(fileListComModel, fileManager, fileLocationItemList);
        
        //List topology files
        url = "gsiftp://gssim.man.poznan.pl:2811/usr/local/admin/gssim/input/topologies/?filetype=directory";
        folderLocation = new FileLocation(url);
        fileManager = fileResourceManager.createFileManager(folderLocation);
        fileLocationItemList = new ArrayList<HashMap>();
        fileListComModel.setTopologiesFileLocationItemList(fileLocationItemList);
        loadFileLocationItemsForCurrentLocation(fileListComModel, fileManager, fileLocationItemList);
        
        //List resource files
        url = "gsiftp://gssim.man.poznan.pl:2811/usr/local/admin/gssim/input/resources/?filetype=directory";
        folderLocation = new FileLocation(url);
        fileManager = fileResourceManager.createFileManager(folderLocation);
        fileLocationItemList = new ArrayList<HashMap>();
        fileListComModel.setResourcesFileLocationItemList(fileLocationItemList);
        loadFileLocationItemsForCurrentLocation(fileListComModel, fileManager, fileLocationItemList);
        
        //reset current location
        url = "gsiftp://gssim.man.poznan.pl:2811/usr/local/admin/?filetype=directory";
        folderLocation = new FileLocation(url);
        fileManager = fileResourceManager.createFileManager(folderLocation);
        HashMap<String, String> currentLocationItem = new HashMap<String, String>();
        fileListComModel.setCurrentLocationItem(currentLocationItem);
        currentLocationItem.put("real_path", folderLocation.getFilePath());
        currentLocationItem.put("path", fileManager.getCurrentDirectory());
        currentLocationItem.put("url", folderLocation.getUrl());
        currentLocationItem.put("downloadUrl", VineFlexUtilClass.getDownloadURL(folderLocation));
    }
	
	public void loadFileLocationItemsForCurrentLocation(GSSimStudioModel fileListComModel, FileManager fileManager, ArrayList<HashMap> fileLocationItemList) throws IOException {

        log.debug("loadFileLocationItemsForCurrentLocation");

        try {

            // Update current folder location
            FileLocation folderLocation = fileManager.getCurrentLocation();

            // Current location item
            HashMap<String, String> currentLocationItem = new HashMap<String, String>();
            fileListComModel.setCurrentLocationItem(currentLocationItem);

            currentLocationItem.put("real_path", folderLocation.getFilePath());
            currentLocationItem.put("path", fileManager.getCurrentDirectory());
            currentLocationItem.put("url", folderLocation.getUrl());
            currentLocationItem.put("downloadUrl", VineFlexUtilClass.getDownloadURL(folderLocation));

            // List files in defafult directory
            List<? extends FileLocation> fileLocationList;
            try {

                fileLocationList = fileManager.list();

            } catch (Exception e) {
                log.error("Error occured during list", e);
                return;
            }

            //String fileDownloadServletUrl = FileDownloadServlet.getResourceUrl();

            for (FileLocation fileLocation : fileLocationList) {

                HashMap<String, String> fileLocationItem = new HashMap<String, String>();
                fileLocationItemList.add(fileLocationItem);

                // File url (not displayed?)
                String fileUrl = fileLocation.getUrl();
                fileLocationItem.put("fileUrl", fileUrl);

                String fileUrlWithoutQuery = fileLocation.getUrlWithoutQuery();
                fileLocationItem.put("fileUrlWithoutQuery", fileUrlWithoutQuery);

                // File name
                String fileName = fileLocation.getFileName();
                fileLocationItem.put("fileName", fileName);

                // File type
                FileType fileType = fileLocation.getFileType();
                fileLocationItem.put("fileType", fileType.getName());

                // Date modified column

                long dateLastModified = fileLocation.getDateLastModified();

                fileLocationItem.put("dateModified", String.valueOf(dateLastModified));

                // Date modified column
                //fileLocationItem.put("dateModifiedText", DateUtil.getLocalizedDate(dateLastModified, DateFormat.MEDIUM, DateFormat.MEDIUM));

                // File size column
                long fileSize = fileLocation.getFileSize();
                fileLocationItem.put("fileSize", String.valueOf(fileSize));

                // File size column
                fileLocationItem.put("fileSizeText", String.valueOf(fileSize) + " bytes");

                fileLocationItem.put("folderUrl", folderLocation.getUrl());
                
                // Download url
                if (fileType.equals(FileType.FILE)) {
                    //fileLocationItem.put("fileDownloadUrl", FileDownloadServlet.getResourceUrlForFileLocation(fileLocation, false));
                }
            }

            log.debug("done");

        } catch (Exception e) {
            log.error("Exception occurred during loadFileLocationGrid", e);
        }
    }
	
	@BlazeDsMethod()
    public GSSimStudioModel deleteFileItem(String fileItemUrl, String currentUrl) throws IOException {

        log.debug("deleteFileItem");

        GSSimStudioModel fileListComModel = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
        //avoid updating experiment list in archive when nothing changed
		fileListComModel.setExperimentListChanged(false);

        try {

            ServiceContext serviceContext = VineFlexUtilClass.getServiceContext();

            FileResourceManager fileResourceManager = getFileResourceManager(serviceContext);

            FileLocation currentLocation = new FileLocation(currentUrl);

            FileManager fileManager = fileResourceManager.createFileManager(currentLocation);

            final FileLocation fileItemLocation = new FileLocation(fileItemUrl);

            FileSet fileSet = new FileLocationSet(new ArrayList<FileLocation>() {
                {
                    add(fileItemLocation);
                }
            });

            TaskMonitor taskMonitor = fileManager.delete(fileSet, TaskOptions.block());

            if (taskMonitor.completed()) {
                // DO NOTHING FOR NOW
            } else if (taskMonitor.failed()) {
                String message = taskMonitor.getTaskStatusMessage();
                //fileListComModel.setError(createErrorMap("deleteFileItem", "Task failed " + message));
            } else {
                log.debug("Task returned with unexpected status: " + taskMonitor.getTaskStatus().getLabel());
                //fileListComModel.setError(createErrorMap("Task returned with unexpected status: ", taskMonitor.getTaskStatus().getLabel()));
            }

            // Reload file location items and current location

            loadFileLocationItems(fileListComModel, fileManager, currentUrl);

        } catch (MalformedURLException e) {
            log.error("Error ocurred in deleteFile", e);
            //fileListComModel.setError(createErrorMap("Error ocurred in deleteFile: ", e.getMessage()));
        }

        return fileListComModel;

    }
	
	private HashMap<String, String> createErrorMap(String method, String message) {
        HashMap<String, String> res = new HashMap<String, String>();
        res.put("method", method);
        res.put("message", message);
        res.put("timestamp", String.valueOf(new Date().getTime()));
        return res;
    }
	
	@BlazeDsMethod()
    public Object init(Object model) {
        log.debug("init() called");
		GSSimStudioModel gssimStudioModel = (GSSimStudioModel) model;
		//avoid updating experiment list in archive when nothing changed
		gssimStudioModel.setExperimentListChanged(false);
		if (gssimStudioModel == null)
			gssimStudioModel = (GSSimStudioModel) VineFlexUtilClass.getUIModel();
        initFileManagerModel(gssimStudioModel);
        getPluginsFromDb(gssimStudioModel);
        return getExperimentsFromDb(gssimStudioModel, null, null, null);
    }
	
	@BlazeDsMethod()
    public Object reinit(Object model) {
        return init(model);
    }

    @BlazeDsMethod()
    public Object clientRebound(Object model) {
        return init(model);
    }
	
	public void initFileManagerModel(GSSimStudioModel gssimStudioModel) {
        ServiceContext serviceContext = VineFlexUtilClass.getServiceContext();
        initFileManagerModel(gssimStudioModel, serviceContext);
    }
	
	public void initFileManagerModel(GSSimStudioModel gssimStudioModel, ServiceContext serviceContext) {

        log.debug("initFileManagerModel");

        try {
            // Get file resource manager
            FileResourceManager fileResourceManager = getFileResourceManager(serviceContext);

            // Build favorite and server location lists, return default location to list

            String currentUrl = (String) gssimStudioModel.getCurrentLocationItem().get("url");

            log.debug("Stored current location url: " + currentUrl);

            String defaultLocationUrl = loadLinkAndServerItems(gssimStudioModel, fileResourceManager, currentUrl);
			log.debug("Stored current location url: " + defaultLocationUrl);
			
			// Load file location items and current location
            loadFileLocationItems(gssimStudioModel, fileResourceManager, defaultLocationUrl);

        } catch (Exception e) {
            log.error("Error ocurred in initFileManagerModel", e);
//            loadErrorMessage(e, "An error occured");
        }
    }
	
	public String loadLinkAndServerItems(GSSimStudioModel gssimStudioModel, FileResourceManager fileResourceManager, String fileLocationUrl) throws MalformedURLException {

        // Get file resource list
        List<? extends FileResource> fileResourceList = fileResourceManager.getFileResources();

        String defaultLocationUrl = fileLocationUrl;

        // Build link location list
        ArrayList<HashMap> linkLocationItemList = new ArrayList<HashMap>();
        gssimStudioModel.setLinkLocationItemList(linkLocationItemList);

        for (FileResource fileResource : fileResourceList) {

            if (fileResource instanceof FileSystemResource) {

                HashMap<String, String> linkLocationItem = new HashMap<String, String>();
                linkLocationItemList.add(linkLocationItem);

                String homeLocationUrl = fileResource.getLocation().getUrl();

                linkLocationItem.put("label", "Home");
                linkLocationItem.put("url", homeLocationUrl);

                // Set default location url if not already set
                if (defaultLocationUrl == null) {

                    linkLocationItem.put("selected", "true");
                }

            }
        }

        //  Build server location list
        ArrayList<HashMap> serverLocationItemList = new ArrayList<HashMap>();
        gssimStudioModel.setServerLocationItemList(serverLocationItemList);

        boolean isSelected = false;

        for (FileResource fileResource : fileResourceList) {

            HashMap<String, String> serverLocationItem = new HashMap<String, String>();

            String serverLocationLabel = fileResource.getLabel();
			
			//FIXME: nie powinno by� po nazwie
			if (serverLocationLabel.equals("Portal File System")) continue;
			serverLocationItemList.add(serverLocationItem);
			
            String serverLocationUrl = fileResource.getLocation().getUrl();

            serverLocationItem.put("label", serverLocationLabel);
            serverLocationItem.put("url", serverLocationUrl);

            // Set default location url if not already set
            if (defaultLocationUrl == null) {

                isSelected = true;

                serverLocationItem.put("selected", "true");
                defaultLocationUrl = serverLocationUrl;


            }
		}

        return defaultLocationUrl;
    }
	
	@BlazeDsMethod()
    public GSSimStudioModel browseResource(String resourceUrl, int selectedServerIdx) throws IOException {

        log.debug("browseResource() called");

        ServiceContext serviceContext = VineFlexUtilClass.getServiceContext();

        GSSimStudioModel fileListComModel = (GSSimStudioModel) VineFlexUtilClass.getUIModel();

        //avoid updating experiment list in archive when nothing changed
		fileListComModel.setExperimentListChanged(false);
        
        FileResourceManager fileResourceManager = getFileResourceManager(serviceContext);

        Iterator<HashMap> it = fileListComModel.getServerLocationItemList().iterator();

        fileListComModel.setSelectedServerIdx(selectedServerIdx);

        int cnt = 0;

        while (it.hasNext()) {
            HashMap<String, String> tmp = it.next();
            if (tmp.containsKey("selected")) {
                tmp.remove("selected");
            }
            if (tmp.get("url").equals(resourceUrl)) {

                tmp.put("selected", "true");
                //fileListComModel.setSelectedServerIdx(cnt);
                //zapamietaj zaznaczony?
            }
            cnt++;
        }

        loadFileLocationItems(fileListComModel, fileResourceManager, resourceUrl);

        return fileListComModel;

    }
	
	public static FileResourceManager getFileResourceManager(ServiceContext serviceContext) {
        return (FileResourceManager) serviceContext.createService(FileResourceManager.KEY);
    }
	
	public long guestUploadSizeLimit() {
        return 1*1024*1024*1024;  //To change body of implemented methods use File | Settings | File Templates.
    }

    public int guestUploadFilesLimit() {
        return 5;  //To change body of implemented methods use File | Settings | File Templates.
    }

    public long loggedInUploadSizeLimit(Principal principal) {
        return -1;  //To change body of implemented methods use File | Settings | File Templates.
    }

    public int loggedInUploadFilesLimit(Principal principal) {
        return -1;  //To change body of implemented methods use File | Settings | File Templates.
    }
    /**************************/
	/** END OF File Manager Methods **/
	/**************************/
}